//UB-S12 "Uber-Shotgun" -- By takato14.

//This is assuming that we have already gotten the Uber Rifle.

datablock AudioProfile(UBS12HiSound)
{
	filename = "./HiFire.wav";
	description = AudioClose3D;
	preload = true;
};

datablock AudioProfile(UBS12ShellLoadSound)
{
	filename = "./ShellLoad.wav";
	description = AudioClose3D;
	preload = true;
};

datablock AudioProfile(UBS12fullSound)
{
	filename = "./slideRelease (2).wav";
	description = AudioClose3D;
	preload = true;
};


AddDamageType("UBS12",   '<bitmap:add-ons/Weapon_UberShotgun/CI_UBS12> %1',    '%2 <bitmap:add-ons/Weapon_UberShotgun/CI_UBS12> %1',0.75,1);

datablock projectileData(UBS12Projectile : UberRifleProjectile)
{
	directDamageType = $damageType::UBS12;
	radiusDamageType = $damageType::UBS12;
	directDamage = 5;
	verticalimpulse = 0;
	shapeFile = "Add-Ons/Weapon_Gun/Bullet.dts";
	uiName = "Uber-Shotgun";
	explosion = gunExplosion;
};

datablock DebrisData(UBS12ShellDebris)
{
	shapeFile = "./shell.dts";
	lifetime = 2;
	minSpinSpeed = -400;
	maxSpinSpeed = 200;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	gravModifier = 2;
};
//////////////////
//ITEM DATABLOCK//
//////////////////
datablock ItemData(UBS12Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./UBS12NH.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Uber-Shotgun";
	iconName = "./icon_UBS12";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	 // Dynamic properties defined by the scripts
	image = UBS12Image;
	canDrop = true;

	maxAmmo = 18;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(UBS12Image)
{
   // Basic Item properties
   shapeFile = "./UBS12.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 0";
   rotation = eulerToMatrix( "0.0 0.3 360" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = UBS12Projectile;
   projectileType = Projectile;

	casing = UBS12ShellDebris;
	shellExitDir        = "1.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 5.0;	
	shellVelocity       = 4.5;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 120;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = UBS12Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = "UberrifleShellDebris";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.68;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]			= "use";
	StateSound[0]				= "weaponswitchsound";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.00;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	StateSequence[2]			= "fire";
	stateSound[2]				= UBS12Hisound;

	stateName[3]				= "Delay";
	stateScript[3]				= "onDelay";
	stateTransitionOnTimeout[3]     	= "FireLoadCheckA";
	stateTimeoutValue[3]            	= 0.25;
	stateEmitter[3]				= uberriflesmokeemitter;
	stateEmitterTime[3]			= 0.5;
	stateEmitterNode[3]			= "muzzleNode";
	stateSound[3]				= UBS12ShellLoadsound;
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout

	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "ReloadWait";
	
	stateName[6]				= "ReloadWait";
	stateTimeoutValue[6]			= 0.3;
	stateTransitionOnTimeout[6]		= "Reload";
	stateWaitForTimeout[6]			= true;
	
	stateName[7]				= "Reload";
	stateTimeoutValue[7]			= 1;
	stateScript[7]				= "onReloadStart";
	stateTransitionOnTimeout[7]		= "ReloadB";
	stateWaitForTimeout[7]			= true;
	StateSequence[7]			= "reloadstart";
	//stateSound[7]				= "";

	stateName[8]				= "ReloadB";
	stateTimeoutValue[8]			= 1.1;
	stateTransitionOnTimeout[8]		= "Reloaded";
	stateWaitForTimeout[8]			= true;
	StateSequence[8]			= "reloadend";
	//stateSound[8]				= "";
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.5;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";

	stateName[10] 				= "Smoke";
	stateEmitter[10]			= uberriflesmokeemitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.1;
	stateTransitionOnTimeout[10]		= "Ready";
	stateTransitionOnTriggerDown[10]	= "Fire";
	
	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= uberriflesmokeemitter;
	stateEmitterTime[11]			= 0.3;
	stateEmitterNode[11]			= "muzzleNode";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "Reload";

	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
};
package UBS12
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
  	 Parent::onTrigger(%this,%obj,%slot,%val);
  	 if(%slot == 4 && %val)
  	 {
 	     if(%obj.getMountedImage(0) == UBS12Image.getID() && %obj.client.LoadTimes <= 2 && %obj.toolAmmo[%obj.currTool] > 0)
     	 {
			//echo(%obj.client.LoadTimes);
			if(%obj.client.LoadTimes == 0)
			{
				%obj.client.LoadTimes++;
			}
		     %obj.client.LoadTimes++;
    	      	%obj.toolAmmo[%obj.currTool]--;
			//echo(%obj.toolAmmo[%obj.currTool]);
			//echo(%obj.client.LoadTimes);
    	      	serverPlay3D(UBS12ShellLoadSound,%obj.getTransform());
      
		}
		 else if(%obj.getMountedImage(0) == UBS12Image.getID())
		 {
			//echo(%obj.client.LoadTimes);
			serverPlay3D(UBS12FullSound,%obj.getTransform());
		  }
		}
	}
};
activatePackage(UBS12);

function UBS12image::onFire(%this,%obj,%slot)
{
	if(%obj.client.LoadTimes == 0)
	{
		%obj.client.LoadTimes = 0;
		%obj.client.LoadTimes++;
	}
	%projectile = %this.projectile;
	%spread = 0.00273;
	%shellcount = 9*(%obj.client.LoadTimes);
	%obj.toolAmmo[%obj.currTool]--;
	%sVelocity = vectorScale(%this.shellExitDir, %this.shellVelocity);
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		//%s = new (%this.DebrisType) ()
		//{
			//dataBlock = %debris;
			//initialVelocity = %sVelocity;
			//initialPosition = %obj.getEjectPoint(%slot);
			//sourceObject = %obj;
			//sourceSlot = %slot;
			//client = %obj.client;
		//};
		%obj.client.LoadTimes = 0;
		MissionCleanup.add(%p);
	}
	return %p;
}
function UBS12Image::onDelay(%this, %obj, %slot)
{	
	%obj.client.LoadTimes++;
	echo(%obj.client.LoadTimes);
}

function UBS12Image::onMount(%this, %obj, %slot)
{	
	%obj.hidenode("RHand");
        %obj.hidenode("LHand");
}


function UBS12Image::onUnMount(%this, %obj, %slot)
{	
	%obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function UBS12Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function UBS12image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 18;
	%obj.setImageAmmo(%slot,1);
}
